/* function Diffu for pmap.c & xpmap.c */

#include "pmap.h"
static int *ff=NULL, *Ng=NULL;

/*********************************************************************/
static int FNgR(int n)		/* range for neighbourhood in Hg row */
{
int i,j, b =MAXINT;
for (i=0; i< hwt; i++) if (i !=n && (j=Hg[n*hwt+i]) < b) b = j;
j=b+Hg[n*hwt+n]; /* range for neighbourhood */
return(j);
}

/********************************************************************/
int FindNghbr()		/* zistenie z Hg */
{
int n,i,j,s,m;
for (m=n=0; n< hwt; n++) { 
  j=FNgR(n); for (s=i=0;i<hwt;i++) if(i !=n && Hg[n*hwt+i] <= j) s++;
  if(m<s)m=s;
}
return(m);
}

/********************************************************************/
static int SetNghbr(int n)		/* vytvorenie n-teho riadku Ng z Hg */
{
int i,j,s;
j=FNgR(n); for (s=i=0;i<hwt;i++) if(i !=n && Hg[n*hwt+i] <= j)
		if(s<nghbr) Ng[n*nghbr+(s++)]=i; else EXF
for (i=s; i<nghbr; i++) Ng[n*nghbr+i]=-1;
return(s);
}

/********************************************************************/
static int GetNghbr(int n)	/* da len pocet susedov */
{ int m; for (m=0; m<nghbr && Ng[n*nghbr+m]>=0; m++); return(m); }


/********************************************************************/
static void SetNg()	/* ak x ma suseda y, musi aj y mat za suseda x	*/
{			/* ak by to neslo, zrusi sa susednost x->y 	*/
int i,j,k,m,s=0;
for (i=0; i<hwt; i++) SetNghbr(i);
for (i=0; i<hwt; i++) for (j=0; j<nghbr && (k=Ng[i*nghbr+j])>=0 ;j++) {
  for (m=0; m<nghbr && (s=Ng[k*nghbr+m])>=0 && s!=i; m++);
  if (s!=i) { if (m<nghbr) Ng[k*nghbr+m]=i;
	      else { Ng[i*nghbr+j]=-1;
		     for (s=j;s+1<nghbr && Ng[i*nghbr+s+1]>=0;s++) {
		       Ng[i*nghbr+s]=Ng[i*nghbr+s+1]; Ng[i*nghbr+s+1]=-1; }
	      }
  }
}
}

/******* for Boillat : HCT stands for "high communicating task" **************/
static int RandHCT(int ii)
{
#define b1 iter/5	/* start HCT preferring time  		=> iter/4 */
#define b2 iter		/* stop HCT preferring time 		=> iter   */
#define b3 3		/* start HCT preferring power divisor 	=> 1	  */
int b;

b = b2-ii; b *= iter; b /= b3; b /= b2-b1; 
/* b = klesajuca pravdepodobnost pre (b1 <= ii <= b2) z hodnoty iter/b3 -> 0 */ 
return(!(ii < b1 || Rand(iter) > b));
}

/******* for Muoj ************************************************************/
static int SetAlfa(int ii)
{
#define k4p 200	/* -- presvihnutie vplyvu komunikacii v prvom polcase (%) */
#define o1 (iter/4)+1	/* -- prvy usek so zvacsenou vahou komunikacii */
#define o2 50		/* -- start percentage for 2-nd part */
/* -- klesajuci nasobitel pre  0 <= ii <= o1   :   iter -> 0 : */
/* -- klesajuci nasobitel pre o1 <= ii <= iter   :   o3 -> 0 : */
int a;

a = alpha * iter; 
if (ii < o1) {a *= k4p; a *= o1-ii; a /= o1;}
else { a *= o2; a *= iter-ii; a /= iter-o1+1;}
a /= 100; a /= iter;
return(a);
}

/***************************************************/
static int Jadro(int n, int af, int ii, int modd, int *target)
{
int *am=NULL;	/* am[nghbr] */	/* either choosen task to move */
				/* or recomended amount of throw-away load */ 
int *mx=NULL;	/* mx[nghbr] */	/* choosen task to move cost */
int s;				/* number of neighbours */
int b=0,i,j,m;
int tsk,newl;			/* choosen task for move to node newl */
int hct=0;			/* High Communicating Task moving */
#define nmx 80			/* pocet pamatanych maxim */
int pmx[nmx];

/* initialization : */
if((am = (int *) malloc(nghbr*sizeof(int)))==NULL)EXM
if((mx = (int *) malloc(nghbr*sizeof(int)))==NULL)EXM
if (modd == 'B') hct = RandHCT(ii); s=GetNghbr(n);
for (i = 0; i< s; i++) { j=Ng[n*nghbr+i]; am[i] = Load[n]*He[n] - Load[j]*He[j]; }
for (i = 0; i< swt; i++) for (j = 0; j< s; j++) ff[i*nghbr+j] = -1;

/* load - balance demand : */
if (modd != 'B' || !hct)
for (i = 0; i < swt; i++) if (Loc[i] == n)
 for (j = 0; j < s; j++) 
 { if (am[j] > (s+1)*Sg[i]*He[n]) b = beta * Sg[i]*He[n];
   else { b = beta * (am[j] - Sg[i]*He[n]); b /= s; }  /* beta->zvysenie presnosti */
   ff[i*nghbr+j] = b;
 }   

/* communication - minimizing demand : */
if (modd != 'B' || hct)
  {int fff,x;
   for (i = 0; i < cht; i++)
    if (Loc[tsk = Cg[i][x = 0]] == n || Loc[tsk = Cg[i][x = 1]] == n) 
     for (j = 0; j < s; j++)
	{m=Ng[n*nghbr+j]; b=Loc[Cg[i][x^1]]; fff = Cg[i][2] * (Hg[n*hwt+b] - Hg[m*hwt+b]);
	if (modd == 'F') ff[tsk*nghbr+j] += fff * alpha;
	if (modd == 'B') ff[tsk*nghbr+j] += fff;
	if (modd == 'D') ff[tsk*nghbr+j] += fff * af;
	}
  }

/* choosing the best task allowed to move for each link : */
for (j = 0; j < s; j++)
 {int p;
  p = 0;
  mx[j] = -1;
  for (m = i = 0; i < swt; i++) if ( i != fixed)  
   { b = ff[i*nghbr+j]; if (m == 0 && b == 0 && Rand(100) < diverg) b++;
     	  if (m  > b) ; 
     else if (m == b) { if (p < nmx && Move(i,Ng[n*nghbr+j],FALSE)) pmx[p++] = i; }
     else if (Move(i,Ng[n*nghbr+j],FALSE)) { p = 0; pmx[p++] = i; m = b; }
   }
  if (p > 0) { mx[j] = m; am[j] = pmx[Rand(p)]; }
 }

/* choosing the best link : */
tsk = newl = b = -1;
for (j = 0; j < s; j++)
  if (b < mx[j]) { b = mx[j]; tsk = am[j]; newl = Ng[n*nghbr+j]; }

/* moving the best task : */
if (tsk >= 0) 
 if (!Move(tsk,newl,TRUE)) {printf("\n!MOVING %d -> %d ERROR!",tsk,newl);tsk=-1;}

*target=newl; return(tsk);
}

/*****************************************************************************/
void Diffu(char modd)
{
extern int InitialPlacing(int start);
extern int pvm_lvgroup(char *gr);
int n,ii,tsk,target;
int af=1;				/* modificated alpha */
/* int ff[swt][nghbr]; 	 * attractive vector */
/* int Ng[hwt][nghbr];	 * H - graph : neighbours */

nghbr=FindNghbr();
if((ff = (int *) malloc(swt*nghbr*sizeof(int)))==NULL)EXM
if((Ng = (int *) malloc(hwt*nghbr*sizeof(int)))==NULL)EXM
ReadTime();  SetNg(); Animat(0); InitialPlacing(START);
for (ii = 1; ii <= iter; ii++) {
#ifdef PG_PVM
  if(ii%2==1)pg_start("iter");
  /*  if(ii%2==1)pg_start("odd"); */
/*  if(ii%2==0)pg_start("even"); */
#endif
if (modd == 'D') af = SetAlfa(ii);
  if (me<=0 && nptsk<2) for (n=0; n<hwt; n++) Jadro(n,af,ii,modd,&target);
  else {tsk=Jadro(me,af,ii,modd,&target); SynchData(tsk,target);}
#ifdef PG_PVM
  if(ii%2==1)pg_end("iter");
  /*  if(ii%2==1)pg_end("odd"); */
/*  if(ii%2==0)pg_end("even"); */
#endif
  Animat(ii);
  if(Xstop){ii=iter+1;if(!NoPVMrunning()){KillGroup();pvm_lvgroup(GROUP);me=-1;}}
}
free((void *)Ng); Ng=NULL;
free((void *)ff); ff=NULL;
}

