/* functions Main1 & Main2 for pmap.c & xpmap.c */

#include "pmap.h"
#include <string.h>
#define VERSION "0.9.8"

int hwt,swt=0,cht;	/* actual table sizes */
int sumload;		/* computational load sum */
float timeconsum;	/* consumed time */
int fixed;		/* fix-placed task number */
int start;		/* start node */
int alpha,beta;		/* weight multiplicators (alpha for communications) */
int dist,nghbr=0;	/* average HW distantion, max.neighbourhood */
int iter;		/* number of iterations */
int diverg;		/* divergence (for equivalent results) */
int averspeed;		/* average "speed", in time needed for computing an unit : */
/*int He[NILNOD]	;* H - graph : 1/efficiency, 2-nd half for short-period val. */
/*int Hg[NILNOD][NILNOD];* H - graph : distances */
/*int Sg[NILTASK];	 * S - graph : comp.load */
/*int Cg[NILCHAN][3];	 * S - graph : comm.load */
/*int Loc[NILTASK];	 * output vector : task placement */
/*int Load[NILNOD];	 * load on nodes */
/*int pvi[NILNOD];	 * input ports on the node */
/*int pvo[NILNOD];	 * output ports on the node */
int *He=NULL, *Hg=NULL, (*Cg)[3]=NULL, *Sg=NULL, *Loc=NULL, *Load=NULL;
#if PVIOCHECK
 int *pvi=NULL, *pvo=NULL;
#endif
char buff[MAXBUFF];	/* working buffer */
char *nout=NULL;	/* Result file name */
char *version=NULL;
char *argv0=NULL;	/* command line parameter 0 - program name */
int  arg4, arg5;	/* command line auxiliary parameters */
char mode=MODEDEF;	/* mapping mode:0,1,2,3,4,H,D,B,F,S,A */
char modeGRP=MODEDEF;	/* last saved mode into the GRP file */
FILE *fi,*fo,*gfo;
char *BL = "\033[A";	/* Back Line */
char *NBL= "\000";	/* no Back Line */
int scroll=-1;		/* can TERM scroll-up? ->  #lines */
int color=FALSE;	/* can TERM print in color ? */
int grpfound=FALSE;	/* new or old fashion input file? */
int Xstop=FALSE;	/* signalling from X */
int Xexit=FALSE;	/* signalling from X */
int XshowView=FALSE;	/* signalling to X */
int gred=FALSE;		/* running from GRED ? */
int npvm, ok;		/* #number of PVM hosts, should be mapping done ? */
int nptsk, me=-1;	/* #number of parallel PVM tasks, instance number */
int sumspeed, hgrd;	/* sum_host_speed,   do get HgTables from alive PVM */

extern int pvm_gsize(char *);
extern int pvm_lvgroup(char *);
extern int pvm_exit();
extern int atoi(char *);
static int IsX(char *);
static char *GetTaskName(char *);
static int inputGot=FALSE;	/* is GRP-file read yet ?  Do not do it again ! */

/*********************************************
int StartDLB()
{int i=0;
  sprintf(buff,"loader -f %s -s %s -r\n",appname,nout);
  printf("...executing :> %s",buff);
  printf("... ale nevykonam, hihihi sfinx asi nejde... a GRED to uz vie!\n");
  \* i=(system(buff)); *\
  return(i);
} *****************************************/

/***********************************************************************/
void Main1(int argc, char *argv[])
{
NewSeed=0; nptsk=0; ok=TRUE; me=-1;
FindHZ(); if(version==NULL)version=strdup(VERSION); if(argv0==NULL)argv0=argv[0];
if(me<0) { GetHgInfo(); if(!inputGot) hwt=npvm; } /* set me, npvm */
_PG_start();
if(me<=0 && scroll<0)scroll = GetScroll(); /* set color for "cprintf" */
if(npvm>0 && (IsX(argv[0]) || me==0)) if(pvm_gsize(GROUP)>1) KillGroup();
if(me<=0)	{	/* without_PVM me<0, else me==0 is master, other is worker */
  if(argc<2) { printf("%s %s\n",argv[0],version); 
	       cprintf("usage:%s GRP_file\n",argv[0]); exit(3); }
  if(!inputGot){
    if(argc==5 &&
       strcmp(argv[3],"grpsocket")==0 && strcmp(argv[4],"animsocket")==0) {
      gred=TRUE; appname=strdup(argv[1]); grpname=strdup(argv[2]); }
    else grpname=strdup(argv[1]);
    /* if(grpname[0]=='-') {
       sprintf(buff,"#PVM=?? ...wait");
      View_hw(buff,FALSE);
      }
    */
  }
  if(!inputGot) grpfound=GRPtest(); /* ok, appname */
 
  if(grpfound) { 
    if(!inputGot) {
      GRPreadArg(argc,argv);	/* arg4, arg5, mode */
      GRPread();		/* swt,cht,sumload,Sg[],Cg[],nout,ok,mode,hwt, */
      inputGot=TRUE;		/* ?Hg[],?He[],?averspeed,hgrd,?Loc[] */
    }
    if(ok && !hgrd && npvm>0) hgrd=xGRPusePVM();
    if(hgrd) {    /* set Hg[] + PVM_SPAWNothers*/
      printf("\n...spawning into PVM    \n%s",BL);
      printf("                     \r");
      GetHgTables(GetTaskName(argv[0])); ReallocLoad(); SetLoad(); }
    /* set Hg[] + PVM_SPAWNothers*/
    if(hwt<1) {cprintf(" Nothing to do! (#hw=0)\n%s",""); exit(0);}
  }
  else { 
    if(!inputGot) {
      hgrd=!ok;
      if(ok)
	{cprintf("%sTrying to use old format of input files: SW & HW graphs!\n","");}
      else { Setgnout(argc, argv);
	     cprintf("%sUsing old format for output file (HW graph)!\n","");
      }
      if(argc==2 && (fi=fopen(argv[1],"r"))!=NULL) hgrd=SWtestHW();
      else
	hgrd=(hgrd || (argc>2 && (argv[1][0]=='-' || argv[2][0]=='-')));
      if(hwt<1 && hgrd) {cprintf(" Nothing to do! (#hw=0)\n%s","");exit(2);}
    }
    if(hgrd)GetHgTables(GetTaskName(argv[0]));    /* set nptsk + PVM_SPAWN others */
    /* ak treba HW zmerat, tak tu, aby to X vedel po skonceni Main1() zobrazit */
    /* a je tu este jeden moment: HWread moze aj zapisovat !*/
    if(!inputGot) {
      ReadArg(argc,argv);	/* set namehw, arg4, arg5, ok */
      if(ok) SWread(argv[1]); /* swt, cht, sumload, Sg[], Cg[], namehw, nout, ok */
      /*if(ok)*/ HWread(argv[1][0]);/* namehw (hgrd) -> ? hwt, ? Hg[], ok */
      inputGot=TRUE;
    }
    if(ok && !hgrd && npvm>0) {
      hgrd=xGRPusePVM();
      if(hgrd) GetHgTables(GetTaskName(argv[0]));
    }
  }
  if(ok) nghbr=FindNghbr();
}
if(!ok && !hgrd) exit(2);
if(hgrd)ReorganizeHW();
}

/***********************************************************************/
void Main2(char *argv[])
{
if(me<=0)	{	/* bez_PVM me<0, inak me==0 je master, ostatni slave */
if(ok)Adapt();		/* arg4,arg5 -> alpha,beta, dist,iter,diverg,mode */  
if(ok)	{int npp=nptsk; nptsk=1; /* temporary for not-parallel methods */
if(hwt==1) { cprintf(" Trivial solution!\n%s","");mode='0';/*grpsavOp=TRUE;*/ }
if(mode=='0' || mode == 'A') {Greedy0();  Result("0","QUICK:rand.nocheck ","");}
if(mode=='1' || mode == 'A') {Greedy1();  Result("1","QUICK:random       ","");}
if(mode=='2' || mode == 'A') {Greedy2();  Result("2","QUICK:to_most_free ","");}
if(mode=='3' || mode == 'A') {Greedy3();  Result("3","QUICK:larg_firs_fr ","");}
if(		mode == 'A') Printline('-');
if(mode=='4' || mode == 'A') {Greedy4();  Result("4","QUICK:fit_larg_com ","ab");}
ok=(mode=='A' ||mode=='F' ||mode=='B' ||mode=='D' ||mode=='H' ||mode=='S');
nptsk=npp; /* restore, function Result() depends on */
	}
		}
/* - - - - - - - - - - - - - - - - - - AZ TU MOZE BYT DISTRIBUOVANY VYPOCET : */

PG_start("HG");
if(!hgrd && ok)GetHgTables(GetTaskName(argv[0]));
					/* set nptsk + PVM_SPAWN others */
/*if(!ok) swt=cht=0;*/			/* me<=0 */
if(me>=2*npvm)hwt=atoi(argv[1]);	/* ... I am added ... */
if(ok) SpawnAdded(GetTaskName(argv[0]), (mode!='H' && mode!='S' && npvm>1)); 
 /* set nptsk = 2*npvm+added -> added=hwt-2*npvm OR 0 */
PG_end("HG");
PG_start("spread");
if(nptsk>0) {if(me==0) SpreadData(); else GetData();} /* hwt, nptsk ... */
if(mode=='H' || mode=='S') nptsk /=2;  /* higher quality if DISTRIBUTED */
else {
 if(nptsk<hwt) {nptsk=1; if (me==0) cprintf(" PVM will not be used!%s","");}
 if(nptsk>hwt)  nptsk=hwt;	/* not needed process */
}
PG_end("spread");
if(me>=nptsk) {	    pvm_lvgroup(GROUP); _PG_end(); pvm_exit(); exit(0);}
				/* tu skonci nepotrebny proces */
if (ok) {
  if(nptsk<2 && me==0) {pvm_lvgroup(GROUP); pvm_exit(); me=-1;} /* exit PVM */
  PG_start("wait");
  if(!NoPVMrunning())while(pvm_gsize(GROUP)>nptsk); /* wait */
  PG_end("wait");
  if(me==0) cprintf(" DISTRIBUTED \n%s",BL);
  
  if(mode=='F'||mode == 'A') {Diffu('F'); Result("F","SMART:fixed alf/bet","abi");}
  if(mode=='B'||mode == 'A') {Diffu('B'); Result("B","SMART: Boillat     ","i");}
  if(		mode == 'A') Printline('-');
  if(		mode == 'A') iter /= 4;
  if(mode=='D'||mode == 'A') {Diffu('D'); Result("D","SMART: diffusion   ","abi");}
  if(		mode == 'A') {Diffu('B'); Result("B:4","SMART: Boillat :4  ","i");}
  if(		mode == 'A') iter *= 2;
  if(		mode == 'A') {Diffu('B'); Result("B:2","SMART: Boillat :2  ","i");}
  if(mode=='H'||mode == 'A') {Hme();      PG_Result("H","HEURIS:MoveExchange","ab");}
  if(mode=='S'||mode == 'A') {SimAnn();   PG_Result("S","SA:SimulatAnnealing","ab");}
}

if(me<=0) PrintTime();
if(me>=0) { pvm_lvgroup(GROUP); _PG_end(); pvm_exit(); }
if(!Xstop && me<=0 && !XshowView) GRPsave();
/* StartDLB(); */
return;
/* exit 0=O.K.  1=internal_limit,algorithm  2=file_r/w  3=file_format */
}


/******************************************************************************/
/* X-task must be only one (problems with "pvmd" - can not provide "display") */
/******************************************************************************/

static char *Strip(char *in)
{
char *ss;
ss=in;
if(in==NULL || (strlen(in)==0) || ((ss=strrchr(in,'/'))==NULL) )return(in);
return(++ss);
}

static int IsX(char *n)
{
int c;
c=Strip(n)[0];
return(c=='x' || c=='X');
}
  
static char *GetTaskName(char *in)
{
char *out=NULL;
out=Strip(in);
if(IsX(in)) out++;
return(out);
}
